<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "twilio_partner".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "TwilioPartner".
 *
 * Columns in table "twilio_partner" available as properties of the model,
 * followed by relations of table "twilio_partner" available as properties of the model.
 *
 * @property string $id
 * @property integer $partner_site_id
 * @property integer $for_showcase
 * @property string $name
 * @property string $address
 * @property string $address_2
 * @property string $phone_number
 * @property string $fax_number
 * @property string $email
 * @property string $website
 * @property integer $enabled
 *
 *
 *     @property TwilioNumber[] $twilioNumbers
 */
abstract class BaseTwilioPartner extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'TwilioPartner|TwilioPartners', $n);
    }

    public function tableName()
    {
        return 'twilio_partner';
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('partner_site_id, for_showcase, enabled', 'numerical', 'integerOnly' => true),
            array('name, address, address_2', 'length', 'max' => 80),
            array('phone_number, fax_number', 'length', 'max' => 14),
            array('email', 'length', 'max' => 254),
            array('website', 'length', 'max' => 255),
            array('partner_site_id, for_showcase, address, address_2, phone_number, fax_number, email, website, '
                . 'enabled', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, partner_site_id, for_showcase, name, address, address_2, phone_number, fax_number, email, '
                . 'website, enabled', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'twilioNumbers' => array(self::HAS_MANY, 'TwilioNumber', 'twilio_partner_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_id' => Yii::t('app', 'Partner Site'),
            'name' => Yii::t('app', 'Name'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'fax_number' => Yii::t('app', 'Fax Number'),
            'email' => Yii::t('app', 'Email'),
            'website' => Yii::t('app', 'Website'),
            'for_showcase' => Yii::t('app', 'For Showcase Pages Only'),
            'enabled' => Yii::t('app', 'Enabled'),
            'twilioNumbers' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('for_showcase', $this->for_showcase);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('fax_number', $this->fax_number, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('website', $this->website, true);
        $criteria->compare('enabled', $this->enabled);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

}
